
#include <schpin_lib_exp/protocol/config.h>
#include <schpin_lib_exp/protocol/register_map.h>

#pragma once

namespace schpin
{
enum fw_config_enum : uint8_t
{
        INPUT_BUFFER_TELEM_PERIOD_MS = 0,
        EVENT_BUFFER_TELEM_PERIOD_MS = 1
};

using fw_config_map_def = protocol_map<
    fw_config_enum,
    protocol_reg< INPUT_BUFFER_TELEM_PERIOD_MS, clk_time >,
    protocol_reg< EVENT_BUFFER_TELEM_PERIOD_MS, clk_time > >;

struct fw_config_map : fw_config_map_def
{
        fw_config_map()
          : fw_config_map_def( clk_time::from_float( 0.5f ), clk_time::from_float( 0.5f ) )
        {
        }
};

}  // namespace schpin
