#include "fw/base.h"
#include "fw/dynmx/base.h"

#include <schpin_lib_exp/protocol/register_map.h>

#pragma once

namespace schpin
{
enum dynmx_config_enum : uint8_t
{
        DYNMX_INPUT_RANGE_LOW  = 0,
        DYNMX_INPUT_RANGE_HIGH = 1,
        DYNMX_SERVO_RANGE_LOW  = 2,
        DYNMX_SERVO_RANGE_HIGH = 3
};

using dynmx_config_map_def = protocol_map<
    dynmx_config_enum,
    protocol_reg< DYNMX_INPUT_RANGE_LOW, bangle >,
    protocol_reg< DYNMX_INPUT_RANGE_HIGH, bangle >,
    protocol_reg< DYNMX_SERVO_RANGE_LOW, dynmx_angle >,
    protocol_reg< DYNMX_SERVO_RANGE_HIGH, dynmx_angle > >;

struct dynmx_config_map : dynmx_config_map_def
{
        using dynmx_config_map_def::protocol_map;

        dynmx_config_map()
          : dynmx_config_map_def(
                bangle::from_float( 0.f ),
                bangle::from_float( 4.18879f ),
                dynmx_angle::get< 0 >(),
                dynmx_angle::get< 4095 >() )
        {
        }
};

}  // namespace schpin
